function varargout = explore_significant_pathways(varargin)
% EXPLORE_SIGNIFICANT_PATHWAYS MATLAB code for explore_significant_pathways.fig
%      EXPLORE_SIGNIFICANT_PATHWAYS, by itself, creates a new EXPLORE_SIGNIFICANT_PATHWAYS or raises the existing
%      singleton*.
%
%      H = EXPLORE_SIGNIFICANT_PATHWAYS returns the handle to a new EXPLORE_SIGNIFICANT_PATHWAYS or the handle to
%      the existing singleton*.
%
%      EXPLORE_SIGNIFICANT_PATHWAYS('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in EXPLORE_SIGNIFICANT_PATHWAYS.M with the given input arguments.
%
%      EXPLORE_SIGNIFICANT_PATHWAYS('Property','Value',...) creates a new EXPLORE_SIGNIFICANT_PATHWAYS or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before explore_significant_pathways_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to explore_significant_pathways_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help explore_significant_pathways

% Last Modified by GUIDE v2.5 11-Jul-2018 15:42:55

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @explore_significant_pathways_OpeningFcn, ...
                   'gui_OutputFcn',  @explore_significant_pathways_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before explore_significant_pathways is made visible.
function explore_significant_pathways_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to explore_significant_pathways (see VARARGIN)
pca_loadings=[];
best_list={};
% pc1_pathwaylist={};
% pc2_pathwaylist={};
%Don't need pca_loadings separate anymore as best_list.loadings has them.
% handles.pca_loadings=[];
% handles.pc1_pathwaylist={};
% handles.pc2_pathwaylist={};
handles.gene_names={};
for i=1:2:length(varargin)
    switch varargin{i}
%         case 'loadings'
%             handles.pca_loadings = varargin{i+1};
        case 'best_list'
            best_list = varargin{i+1};
%         case 'enriched_pc1'
%             handles.pc1_pathwaylist = varargin{i+1};
%         case 'enriched_pc2'
%             handles.pc2_pathwaylist = varargin{i+1};
        case 'gene_names'
            handles.gene_names=varargin{i+1};
        otherwise
            varargin{i} 
            'unrecognised'
    end
end
%remove entries with empty lists from best_list
%Surely this shouldn't be needed, as the bestlist is checked for empty
%entries in the previous script.
% empt=[];
% for e=1:size(best_list,1)   
%     empt(e)=isempty(best_list{e,8});
% end
% handles.best_list=best_list(empt==0,:);
handles.best_list=best_list;
% Choose default command line output for explore_significant_pathways
handles.output = hObject;
%Set defaults for values used in plotting
handles.chull_sig_value=0.05;
handles.pc1_sig=0.05;
handles.pc2_sig=0.05;
handles.pa_sig=0.05;
handles.max_pway_size=10000;
handles.min_pway_size=3;
handles.grey=true;
handles.display_logical=ones(1,size(handles.best_list.genesetNames,2));
handles.search_type='nosearch';
handles.first=1;
handles.min_percent_covered=0.5;
handles.percent_covered_per_pathway = handles.best_list.genesetCovered./repmat(handles.best_list.totalGenes,1,size(handles.best_list.genesetNames,2));
% Update handles structure
guidata(hObject, handles);
replot(hObject, handles);
plotedit off;
pan on;
handles.first=0;
guidata(hObject, handles);


% UIWAIT makes explore_significant_pathways wait for user response (see UIRESUME)
% uiwait(handles.figure1);

% --- Makes the plot
function replot(hObject,handles)
%This function makes/updates the plot based on the latest settings
if handles.first==1
    %First time this function is run, need to plot as normal
    scatter(handles.best_list.loadings(:,1),handles.best_list.loadings(:,2),'+');
else
    %after that need to get the limits.
    old_x_range=get(gca,'xlim');
    old_y_range=get(gca,'ylim');
    scatter(handles.best_list.loadings(:,1),handles.best_list.loadings(:,2),'+');
    xlim(old_x_range);
    ylim(old_y_range);
end
hold on
xlabel('First Component given');
ylabel('Second Component given');
for c=1:size(handles.best_list.genesetNames,2)
    current_display(c)=((handles.percent_covered_per_pathway(c)>=handles.min_percent_covered) && (handles.best_list.genesetPvalues(c)<=handles.chull_sig_value) && (handles.best_list.component1Enrichment(c)<=handles.pc1_sig) && (handles.best_list.component2Enrichment(c)<=handles.pc2_sig) && (handles.best_list.principalAngleEnrichment(c)<=handles.pa_sig) && (handles.best_list.genesetSize(c)<=handles.max_pway_size) && (handles.best_list.genesetSize(c)>=handles.min_pway_size));
end
switch handles.search_type
    case 'members'
        if sum(current_display)>0
            sort_p1p2=handles.best_list.component1Enrichment.*handles.best_list.component2Enrichment;
            sort_p1p2(current_display==0)=100;
            [s,sort_p1p2_order]=sort(sort_p1p2);
            g = greedy_members_one_result(handles.best_list.loadings, handles.best_list.polygonCorners(sort_p1p2_order(1:sum(current_display))), mat2cell(s(1:sum(current_display))',sum(current_display)), 0);
            current_display=zeros(size(handles.best_list.genesetNames,2));
            current_display(sort_p1p2_order(g.list==1))=1;
        end
    case 'area'
        if sum(current_display)>0
            sort_p1p2=handles.best_list.component1Enrichment.*handles.best_list.component2Enrichment;
            sort_p1p2(current_display==0)=100;
            [s,sort_p1p2_order]=sort(sort_p1p2);
            g = greedy_nointersect_one_result(handles.best_list.loadings, handles.best_list.polygonCorners(sort_p1p2_order(1:sum(current_display))), mat2cell(s(1:sum(current_display))',sum(current_display)));
            %ok I've sorted the list here and taken the top, and then found the indices of the
            %ones which don't overlap in the new index.  So need to get back to
            %the old indices - how?? like this!
            current_display=zeros(size(handles.best_list.genesetNames,2));
            current_display(sort_p1p2_order(g.list==1))=1;
        end
    case 'nosearch'
    otherwise
        display(handles.search_type);
end   
for i=1:size(handles.best_list.genesetNames,2)
    %if ~isempty(handles.best_list{i,2})
        %if ((handles.best_list{i,2}<handles.chull_sig_value) && (handles.best_list{i,9}<handles.pc1_sig) && (handles.best_list{i,10}<handles.pc2_sig) && (handles.best_list{i,5}<handles.max_pway_size) && (handles.best_list{i,5}>handles.min_pway_size) && (handles.display_logical(i)==1))
        if current_display(i)==1
            plot([handles.best_list.polygonCorners{i}(1,:),handles.best_list.polygonCorners{i}(1,1)],[handles.best_list.polygonCorners{i}(2,:),handles.best_list.polygonCorners{i}(2,1)],'r','DisplayName',handles.best_list.genesetNames{i}{1});
        elseif handles.grey==true
            plot([handles.best_list.polygonCorners{i}(1,:),handles.best_list.polygonCorners{i}(1,1)],[handles.best_list.polygonCorners{i}(2,:),handles.best_list.polygonCorners{i}(2,1)],'Color',[0.9,0.9,0.9],'DisplayName',handles.best_list.genesetNames{i}{1});
  %          plot([handles.best_list{i,7}(1,:),handles.best_list{i,7}(1,1)],[handles.best_list{i,7}(2,:),handles.best_list{i,7}(2,1)],'Color',[0.9,0.9,0.9]);
        end
   % end
end  
plotbrowser('on');
drawnow;
plotedit off;
pan on;
hold off



% --- Outputs from this function are returned to the command line.
function varargout = explore_significant_pathways_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on slider movement.
function Convex_hull_sig_slider_Callback(hObject, eventdata, handles)
% hObject    handle to Convex_hull_sig_slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
handles.chull_sig_value=10^get(hObject,'Value');
set(handles.qval_chull_text,'String',num2str(handles.chull_sig_value));
replot(hObject, handles);
guidata(hObject,handles);


% --- Executes during object creation, after setting all properties.
function Convex_hull_sig_slider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Convex_hull_sig_slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end



% --- Executes on slider movement.
function max_pathway_size_slider_Callback(hObject, eventdata, handles)
% hObject    handle to max_pathway_size_slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
handles.max_pway_size=get(hObject,'Value');
set(handles.max_size_text,'String',num2str(handles.max_pway_size));
replot(hObject, handles);
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function max_pathway_size_slider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to max_pathway_size_slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function PC1_sig_slider_Callback(hObject, eventdata, handles)
% hObject    handle to PC1_sig_slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
handles.pc1_sig=10^get(hObject,'Value');
set(handles.pc1_sig_text,'String',num2str(handles.pc1_sig));
replot(hObject, handles);
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function PC1_sig_slider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to PC1_sig_slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function PC2_sig_slider_Callback(hObject, eventdata, handles)
% hObject    handle to PC2_sig_slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
handles.pc2_sig=10^get(hObject,'Value');
set(handles.pc2_sig_text,'String',num2str(handles.pc2_sig));
replot(hObject, handles);
guidata(hObject,handles);


% --- Executes during object creation, after setting all properties.
function PC2_sig_slider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to PC2_sig_slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function min_pathway_size_slider_Callback(hObject, eventdata, handles)
% hObject    handle to min_pathway_size_slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
handles.min_pway_size=get(hObject,'Value');
set(handles.min_size_text,'String',num2str(handles.min_pway_size));
replot(hObject, handles);
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function min_pathway_size_slider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to min_pathway_size_slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes when selected object is changed in colour_insignificant_pathways.
function colour_insignificant_pathways_SelectionChangeFcn(hObject, eventdata, handles)
% hObject    handle to the selected object in colour_insignificant_pathways 
% eventdata  structure with the following fields (see UIBUTTONGROUP)
%	EventName: string 'SelectionChanged' (read only)
%	OldValue: handle of the previously selected object or empty if none was selected
%	NewValue: handle of the currently selected object
% handles    structure with handles and user data (see GUIDATA)
if strcmp(get(eventdata.NewValue,'Tag'),'grey_pathways_insig_button')  
    handles.grey=true;
    replot(hObject,handles);
    guidata(hObject,handles);
else
    handles.grey=false;
    replot(hObject,handles);
    guidata(hObject,handles);
end



function qvalue_chull_Callback(hObject, eventdata, handles)
% hObject    handle to qvalue_chull (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of qvalue_chull as text
%        str2double(get(hObject,'String')) returns contents of qvalue_chull as a double


% --- Executes during object creation, after setting all properties.
function qvalue_chull_CreateFcn(hObject, eventdata, handles)
% hObject    handle to qvalue_chull (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function qval_chull_text_Callback(hObject, eventdata, handles)
% hObject    handle to qval_chull_text (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of qval_chull_text as text
%        str2double(get(hObject,'String')) returns contents of qval_chull_text as a double
handles.chull_sig_value=str2double(get(hObject,'String'));
set(handles.Convex_hull_sig_slider,'Value',log10(handles.chull_sig_value));
replot(hObject, handles);
guidata(hObject,handles);


% --- Executes during object creation, after setting all properties.
function qval_chull_text_CreateFcn(hObject, eventdata, handles)
% hObject    handle to qval_chull_text (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function pc1_sig_text_Callback(hObject, eventdata, handles)
% hObject    handle to pc1_sig_text (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of pc1_sig_text as text
%        str2double(get(hObject,'String')) returns contents of pc1_sig_text as a double
handles.pc1_sig=str2double(get(hObject,'String'));
set(handles.PC1_sig_slider,'Value',log10(handles.pc1_sig));
replot(hObject, handles);
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function pc1_sig_text_CreateFcn(hObject, eventdata, handles)
% hObject    handle to pc1_sig_text (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function max_size_text_Callback(hObject, eventdata, handles)
% hObject    handle to max_size_text (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of max_size_text as text
%        str2double(get(hObject,'String')) returns contents of max_size_text as a double
handles.max_pway_size=str2double(get(hObject,'String'));
set(handles.max_pathway_size_slider,'Value',handles.max_pway_size);
replot(hObject, handles);
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function max_size_text_CreateFcn(hObject, eventdata, handles)
% hObject    handle to max_size_text (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function pc2_sig_text_Callback(hObject, eventdata, handles)
% hObject    handle to pc2_sig_text (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of pc2_sig_text as text
%        str2double(get(hObject,'String')) returns contents of pc2_sig_text as a double
handles.pc2_sig=str2double(get(hObject,'String'));
set(handles.PC2_sig_slider,'Value',log10(handles.pc2_sig));
replot(hObject, handles);
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function pc2_sig_text_CreateFcn(hObject, eventdata, handles)
% hObject    handle to pc2_sig_text (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function min_size_text_Callback(hObject, eventdata, handles)
% hObject    handle to min_size_text (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of min_size_text as text
%        str2double(get(hObject,'String')) returns contents of min_size_text as a double
handles.min_pway_size=str2double(get(hObject,'String'));
set(handles.min_pathway_size_slider,'Value',handles.min_pway_size);
replot(hObject, handles);
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function min_size_text_CreateFcn(hObject, eventdata, handles)
% hObject    handle to min_size_text (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes when selected object is changed in greedy_search_options.
function greedy_search_options_SelectionChangeFcn(hObject, eventdata, handles)
% hObject    handle to the selected object in greedy_search_options 
% eventdata  structure with the following fields (see UIBUTTONGROUP)
%	EventName: string 'SelectionChanged' (read only)
%	OldValue: handle of the previously selected object or empty if none was selected
%	NewValue: handle of the currently selected object
% handles    structure with handles and user data (see GUIDATA)
if strcmp(get(eventdata.NewValue,'Tag'),'show_all_button')  
    handles.display_logical=ones(1,size(handles.best_list.genesetNames,2));
    handles.search_type='nosearch';
    replot(hObject,handles);
    guidata(hObject,handles);
else if strcmp(get(eventdata.NewValue,'Tag'),'Greedymembers')
    handles.search_type='members';
    replot(hObject,handles);
    guidata(hObject,handles);
    else if strcmp(get(eventdata.NewValue,'Tag'),'Greedyarea')
        handles.search_type='area';
        replot(hObject,handles);
        guidata(hObject,handles);
        else
            display('wrong search type selected?');
        end
    end
end


% --- Executes on slider movement.
function percent_covered_slider_Callback(hObject, eventdata, handles)
% hObject    handle to percent_covered_slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
handles.min_percent_covered=get(hObject,'Value');
set(handles.percent_covered_text,'String',num2str(handles.min_percent_covered));
replot(hObject, handles);
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function percent_covered_slider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to percent_covered_slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end



function percent_covered_text_Callback(hObject, eventdata, handles)
% hObject    handle to percent_covered_text (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of percent_covered_text as text
%        str2double(get(hObject,'String')) returns contents of percent_covered_text as a double
handles.min_percent_covered=str2double(get(hObject,'String'));
set(handles.percent_covered_slider,'Value', handles.min_percent_covered);
replot(hObject, handles);
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function percent_covered_text_CreateFcn(hObject, eventdata, handles)
% hObject    handle to percent_covered_text (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on slider movement.
function PrincipalAngle_slider_Callback(hObject, eventdata, handles)
% hObject    handle to PrincipalAngle_slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
handles.pa_sig=10^get(hObject,'Value');
set(handles.PrincipalAngle_sig_text,'String',num2str(handles.pa_sig));
replot(hObject, handles);
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function PrincipalAngle_slider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to PrincipalAngle_slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end



function PrincipalAngle_sig_text_Callback(hObject, eventdata, handles)
% hObject    handle to PrincipalAngle_sig_text (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of PrincipalAngle_sig_text as text
%        str2double(get(hObject,'String')) returns contents of PrincipalAngle_sig_text as a double
handles.pa_sig=str2double(get(hObject,'String'));
set(handles.PrincipalAngle_slider,'Value', handles.pa_sig);
replot(hObject, handles);
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function PrincipalAngle_sig_text_CreateFcn(hObject, eventdata, handles)
% hObject    handle to PrincipalAngle_sig_text (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in ExitButton.
function ExitButton_Callback(hObject, eventdata, handles)
% hObject    handle to ExitButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
close(explore_significant_pathways);
